Index: /code/branches/objecthierarchy/init/common/def_keybindings.ini
===================================================================
--- /code/branches/objecthierarchy/init/common/def_keybindings.ini	(revision 1993)
+++ /code/branches/objecthierarchy/init/common/def_keybindings.ini	(revision 1994)
@@ -1,4 +1,4 @@
 [Keys]
-KeyA="scale -1 moveLateral"
+KeyA="scale -1 moveRightLeft"
 KeyABNT_C1=
 KeyABNT_C2=
@@ -16,13 +16,13 @@
 KeyComma=
 KeyConvert=
-KeyD="scale 1 moveLateral"
+KeyD="scale 1 moveRightLeft"
 KeyDelete=
 KeyDivide=
 KeyDown=
-KeyE="scale -1 moveRoll"
+KeyE="scale -1 rotateRoll"
 KeyEnd=
 KeyEquals=
 KeyEscape="exit"
-KeyF=
+KeyF="scale -1 moveUpDown"
 KeyF1="OverlayGroup toggleVisibility Debug"
 KeyF10=
@@ -105,6 +105,6 @@
 KeyPower=
 KeyPreviousTrack=
-KeyQ="scale 1 moveRoll"
-KeyR=
+KeyQ="scale 1 rotateRoll"
+KeyR="scale 1 moveUpDown"
 KeyReturn=
 KeyRight=
@@ -114,5 +114,5 @@
 KeyRightShift=
 KeyRightWindows=
-KeyS="scale -1 moveLongitudinal"
+KeyS="scale -1 moveFrontBack"
 KeyScrollLock=
 KeySemicolon=
@@ -132,5 +132,5 @@
 KeyVolumeDown=
 KeyVolumeUp=
-KeyW="scale 1 moveLongitudinal"
+KeyW="scale 1 moveFrontBack"
 KeyWake=
 KeyWebBack=
@@ -254,7 +254,7 @@
 
 [MouseAxes]
-MouseXNeg="scale 1 moveYaw"
-MouseXPos="scale -1 moveYaw"
-MouseYNeg="scale 1 movePitch"
-MouseYPos="scale -1 movePitch"
+MouseXNeg="scale -1 rotateYaw"
+MouseXPos="scale 1 rotateYaw"
+MouseYNeg="scale 1 rotatePitch"
+MouseYPos="scale -1 rotatePitch"
 
Index: /code/branches/objecthierarchy/src/orxonox/objects/worldentities/ControllableEntity.cc
===================================================================
--- /code/branches/objecthierarchy/src/orxonox/objects/worldentities/ControllableEntity.cc	(revision 1993)
+++ /code/branches/objecthierarchy/src/orxonox/objects/worldentities/ControllableEntity.cc	(revision 1994)
@@ -27,4 +27,5 @@
  */
 
+#include "OrxonoxStableHeaders.h"
 #include "ControllableEntity.h"
 
Index: /code/branches/objecthierarchy/src/orxonox/objects/worldentities/MovableEntity.cc
===================================================================
--- /code/branches/objecthierarchy/src/orxonox/objects/worldentities/MovableEntity.cc	(revision 1993)
+++ /code/branches/objecthierarchy/src/orxonox/objects/worldentities/MovableEntity.cc	(revision 1994)
@@ -27,4 +27,5 @@
  */
 
+#include "OrxonoxStableHeaders.h"
 #include "MovableEntity.h"
 
Index: /code/branches/objecthierarchy/src/orxonox/objects/worldentities/pawns/Spectator.cc
===================================================================
--- /code/branches/objecthierarchy/src/orxonox/objects/worldentities/pawns/Spectator.cc	(revision 1993)
+++ /code/branches/objecthierarchy/src/orxonox/objects/worldentities/pawns/Spectator.cc	(revision 1994)
@@ -27,4 +27,5 @@
  */
 
+#include "OrxonoxStableHeaders.h"
 #include "Spectator.h"
 
Index: /code/branches/objecthierarchy/visual_studio/vc8/core.vcproj
===================================================================
--- /code/branches/objecthierarchy/visual_studio/vc8/core.vcproj	(revision 1993)
+++ /code/branches/objecthierarchy/visual_studio/vc8/core.vcproj	(revision 1994)
@@ -184,4 +184,8 @@
 				>
 			</File>
+			<File
+				RelativePath="..\..\src\core\Template.cc"
+				>
+			</File>
 			<Filter
 				Name="tolua"
@@ -421,4 +425,8 @@
 			</File>
 			<File
+				RelativePath="..\..\src\core\Template.h"
+				>
+			</File>
+			<File
 				RelativePath="..\..\src\core\XMLIncludes.h"
 				>
Index: /code/branches/objecthierarchy/visual_studio/vc8/orxonox.vcproj
===================================================================
--- /code/branches/objecthierarchy/visual_studio/vc8/orxonox.vcproj	(revision 1993)
+++ /code/branches/objecthierarchy/visual_studio/vc8/orxonox.vcproj	(revision 1994)
@@ -231,4 +231,16 @@
 					>
 					<File
+						RelativePath="..\..\src\orxonox\objects\worldentities\ControllableEntity.cc"
+						>
+					</File>
+					<File
+						RelativePath="..\..\src\orxonox\objects\worldentities\Model.cc"
+						>
+					</File>
+					<File
+						RelativePath="..\..\src\orxonox\objects\worldentities\MovableEntity.cc"
+						>
+					</File>
+					<File
 						RelativePath="..\..\src\orxonox\objects\worldentities\PositionableEntity.cc"
 						>
@@ -238,4 +250,12 @@
 						>
 					</File>
+					<Filter
+						Name="pawns"
+						>
+						<File
+							RelativePath="..\..\src\orxonox\objects\worldentities\pawns\Spectator.cc"
+							>
+						</File>
+					</Filter>
 				</Filter>
 				<Filter
@@ -260,4 +280,16 @@
 					<File
 						RelativePath="..\..\src\orxonox\objects\infos\PlayerInfo.cc"
+						>
+					</File>
+				</Filter>
+				<Filter
+					Name="controllers"
+					>
+					<File
+						RelativePath="..\..\src\orxonox\objects\controllers\Controller.cc"
+						>
+					</File>
+					<File
+						RelativePath="..\..\src\orxonox\objects\controllers\HumanController.cc"
 						>
 					</File>
@@ -579,4 +611,16 @@
 					>
 					<File
+						RelativePath="..\..\src\orxonox\objects\worldentities\ControllableEntity.h"
+						>
+					</File>
+					<File
+						RelativePath="..\..\src\orxonox\objects\worldentities\Model.h"
+						>
+					</File>
+					<File
+						RelativePath="..\..\src\orxonox\objects\worldentities\MovableEntity.h"
+						>
+					</File>
+					<File
 						RelativePath="..\..\src\orxonox\objects\worldentities\PositionableEntity.h"
 						>
@@ -586,4 +630,12 @@
 						>
 					</File>
+					<Filter
+						Name="pawns"
+						>
+						<File
+							RelativePath="..\..\src\orxonox\objects\worldentities\pawns\Spectator.h"
+							>
+						</File>
+					</Filter>
 				</Filter>
 				<Filter
@@ -608,4 +660,16 @@
 					<File
 						RelativePath="..\..\src\orxonox\objects\infos\PlayerInfo.h"
+						>
+					</File>
+				</Filter>
+				<Filter
+					Name="controllers"
+					>
+					<File
+						RelativePath="..\..\src\orxonox\objects\controllers\Controller.h"
+						>
+					</File>
+					<File
+						RelativePath="..\..\src\orxonox\objects\controllers\HumanController.h"
 						>
 					</File>