Index: code/branches/physics/src/CMakeLists.txt
===================================================================
--- code/branches/physics/src/CMakeLists.txt	(revision 1988)
+++ code/branches/physics/src/CMakeLists.txt	(revision 1995)
@@ -2,4 +2,7 @@
 INCLUDE_DIRECTORIES(..)
 INCLUDE_DIRECTORIES(orxonox)
+INCLUDE_DIRECTORIES(bullet)
+INCLUDE_DIRECTORIES(ogrebullet/Dynamics)
+INCLUDE_DIRECTORIES(ogrebullet/Collisions)
 
 ADD_SUBDIRECTORY(cpptcl)
Index: code/branches/physics/src/bullet/CMakeLists.txt
===================================================================
--- code/branches/physics/src/bullet/CMakeLists.txt	(revision 1988)
+++ code/branches/physics/src/bullet/CMakeLists.txt	(revision 1995)
@@ -1,4 +1,2 @@
-INCLUDE_DIRECTORIES(.)
-
 ADD_SUBDIRECTORY(BulletSoftBody)
 ADD_SUBDIRECTORY(BulletCollision)
Index: code/branches/physics/src/ogrebullet/CMakeLists.txt
===================================================================
--- code/branches/physics/src/ogrebullet/CMakeLists.txt	(revision 1988)
+++ code/branches/physics/src/ogrebullet/CMakeLists.txt	(revision 1995)
@@ -1,6 +1,2 @@
-INCLUDE_DIRECTORIES(../bullet)
-INCLUDE_DIRECTORIES(Collisions)
-INCLUDE_DIRECTORIES(Dynamics)
-
 ADD_SUBDIRECTORY(Collisions)
 ADD_SUBDIRECTORY(Dynamics)
Index: code/branches/physics/src/orxonox/CMakeLists.txt
===================================================================
--- code/branches/physics/src/orxonox/CMakeLists.txt	(revision 1988)
+++ code/branches/physics/src/orxonox/CMakeLists.txt	(revision 1995)
@@ -49,5 +49,6 @@
   objects/NPC.cc
   objects/ParticleSpawner.cc
-  objects/PhysicsTest.cc
+#  objects/PhysicsTest.cc
+  objects/HelloBullet.cc
   objects/Radar.cc
   objects/RadarListener.cc
Index: code/branches/physics/src/orxonox/objects/HelloBullet.cc
===================================================================
--- code/branches/physics/src/orxonox/objects/HelloBullet.cc	(revision 1995)
+++ code/branches/physics/src/orxonox/objects/HelloBullet.cc	(revision 1995)
@@ -0,0 +1,84 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Martin Stypinski
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#include "OrxonoxStableHeaders.h"
+#include "HelloBullet.h"
+
+#include <OgreStaticGeometry.h>
+#include <OgreSceneManager.h>
+#include <OgreEntity.h>
+
+#include "ogreode/OgreOde_Core.h"
+#include "ogreode/OgreOdeGeometry.h"
+#include "util/Convert.h"
+#include "core/CoreIncludes.h"
+#include "core/ConfigValueIncludes.h"
+#include "core/XMLPort.h"
+#include "GraphicsEngine.h"
+
+namespace orxonox
+{
+    CreateFactory(HelloBullet);
+    
+    HelloBullet::HelloBullet()
+    {
+ 	   RegisterObject(HelloBullet);
+  	   COUT(0) << "HelloBullet loaded" << std::endl ;
+    }
+
+    HelloBullet::~HelloBullet()
+    {
+     // empty
+    }
+
+    void HelloBullet::setConfigValues()
+    {
+
+    }
+
+    /**
+    @brief
+        XML loading and saving.
+    @param
+        xmlelement The XML-element
+    @param	
+        loading Loading (true) or saving (false)
+    @return
+        The XML-element
+    */
+    void HelloBullet::XMLPort(Element& xmlelement, XMLPort::Mode mode)
+    {
+      SUPER(HelloBullet, XMLPort, xmlelement, mode);
+    }
+
+    void HelloBullet::tick(float dt)
+    {
+        // only update physics in a certain interval
+    }
+
+}
Index: code/branches/physics/src/orxonox/objects/HelloBullet.h
===================================================================
--- code/branches/physics/src/orxonox/objects/HelloBullet.h	(revision 1995)
+++ code/branches/physics/src/orxonox/objects/HelloBullet.h	(revision 1995)
@@ -0,0 +1,61 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Martin Stypinski
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#ifndef _HelloBullet_H__
+#define _HelloBullet_H__
+
+#include "OrxonoxPrereqs.h"
+#include "core/BaseObject.h"
+
+#include "ogrebullet/Dynamics/OgreBulletDynamics.h"
+
+#include "Tickable.h"
+
+namespace orxonox
+{
+    class _OrxonoxExport HelloBullet : public BaseObject, public Tickable
+    {
+    public:
+        HelloBullet();
+        virtual ~HelloBullet();
+        void setConfigValues();
+
+        virtual void tick(float dt);
+
+        virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
+
+    private:
+
+    };
+
+
+}
+
+
+
+#endif /* _HelloBullet_H__ */